#include <mem.h>
#include <ctype.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <dos.h>

#define MAXFILES 500
#define TRUE	1
#define FALSE	0
#define DEBUGGING 0

typedef struct dir_display {
		  char            ff_attrib;
		  unsigned        ff_ftime;
		  unsigned        ff_fdate;
		  long            ff_fsize;
		  char            ff_name[13];
		  } DIR_DISPLAY;

static struct {char attrib, disp_char;} attributes[]={
			FA_LABEL,	'L',
			FA_SYSTEM,	'S',
			FA_HIDDEN,  'H',
			FA_DIREC,	'D',
			FA_RDONLY,	'R',
			FA_ARCH, 	'a', NULL};


long 	Total_bytes=0;
int print_thru_dos = FALSE;

void show_files (DIR_DISPLAY  *, int );
char * get_attr (int attrib, char *sAttribute);
char * ck_dir (DIR_DISPLAY  *file);
int file_sorter (const void*, const void* );
int set_path (char working_path[], char**, char*);

main (int argc, char * argv[]) //, char * env[])
{
	int i,j, erc, lastfile, non_switch_index=0;
	static char *path="*.*";
	struct ffblk ffblock;
	DIR_DISPLAY		*files[MAXFILES], *file_array;
	char  working_path[160];

	directvideo = FALSE;
	if (argc > 1) {
		for (i=1; i < argc; i++) {
			if (*argv[i] == '/') {  // a video switch
				switch (tolower(*(argv[i]+1))) {
					case 'b': //BIOS
						directvideo = FALSE;
						break;
					case 'v': //direct to video ram
						directvideo = TRUE;
						break;
					case 'f': //print thru dos
					case 'd': //print thru dos
						print_thru_dos = TRUE;
						break;
					case '?':
					case 'h': // help
					default:
						printf ("gd [path] [video mode] \n\t\t/b: BIOS\n\t\t\/v: direct to video\n\t\t/d: through DOS\n");
						exit(0);
					}
				}
			else
				non_switch_index = i; 	// where the path is
			}
		if (non_switch_index)
			set_path (working_path, &path, argv[non_switch_index]);
		}

	erc = findfirst (path, &ffblock, 0xFF^FA_LABEL); //not the lable
	if (erc) {
		printf ("Could not find %s", path);
		exit(erc);
		}

	Total_bytes = 0;
	lastfile=0;
	do {
		Total_bytes += ffblock.ff_fsize;
		files[lastfile] = (DIR_DISPLAY*) malloc (sizeof(DIR_DISPLAY));
		memcpy (files[lastfile++], &ffblock.ff_attrib, sizeof(DIR_DISPLAY));
		} while ((erc = findnext (&ffblock)) == NULL); // lastfile is a count!

	// allocate an array for the qsort
	file_array = (DIR_DISPLAY*) calloc ((lastfile+5), sizeof(DIR_DISPLAY));

	// don't bother with the ".."  and "." directories
	for (i=0, j=0; i < lastfile; i++) {
		if (*files[i]->ff_name == '.')
			continue;
		memcpy ((file_array+j++), files[i], sizeof(DIR_DISPLAY));
		free (files[i]);
		}
	lastfile = j;	// count of ffblocks actually transferred
	qsort (file_array, lastfile, sizeof(DIR_DISPLAY), file_sorter);
	printf ("%s\n", path);
	show_files (file_array, lastfile);
}

void show_files (DIR_DISPLAY  *file, int lastfile)
{
	int j,i, depth, remainder, fname[5];
	char	sAttribs[5][3];
	static char plural[] = "s";

	depth 		= (lastfile) / 5;
	remainder	= (lastfile) % 5;
	if (remainder)
		depth++;
	for (j=1; j < 5 ; j++) //do not use fname[0]
		fname[j] = depth * j;
	if (print_thru_dos) {
		for (i=0; i < depth; i++) {
			printf ("%-2s%-14s%-2s%-14s%-2s%-14s%-2s%-14s%-2s%s\n",
				get_attr((file+i)->ff_attrib, sAttribs[0]),		ck_dir ((file+i)),
				get_attr((file+i+fname[1])->ff_attrib, sAttribs[1]),
				  ck_dir (file+i+fname[1]),
				get_attr((file+i+fname[2])->ff_attrib, sAttribs[2]),
				  ck_dir (file+i+fname[2]),
				get_attr((file+i+fname[3])->ff_attrib, sAttribs[3]),
				  ck_dir (file+i+fname[3]),
				get_attr((file+i+fname[4])->ff_attrib, sAttribs[4]),
				  ck_dir (file+i+fname[4])
					);
			}
		}
	else {
		for (i=0; i < depth; i++) {
			cprintf ("%-2s%-14s%-2s%-14s%-2s%-14s%-2s%-14s%-2s%s\r\n",
				get_attr((file+i)->ff_attrib, sAttribs[0]),
				 ck_dir ((file+i)),
				get_attr((file+i+fname[1])->ff_attrib, sAttribs[1]),
				  ck_dir (file+i+fname[1]),
				get_attr((file+i+fname[2])->ff_attrib, sAttribs[2]),
				  ck_dir (file+i+fname[2]),
				get_attr((file+i+fname[3])->ff_attrib, sAttribs[3]),
				  ck_dir (file+i+fname[3]),
				get_attr((file+i+fname[4])->ff_attrib, sAttribs[4]),
				  ck_dir (file+i+fname[4])
					);
			}  //for
		} //else
	if (lastfile == 1)
		*plural = NULL;
	printf ("%d File%s; %ld Kbytes.	[arch dir:label sys hidden read]\n",
				lastfile, plural, Total_bytes / 1000);
}

char * get_attr (int attrib, char *sAttribute)
{
	int i;

	if (!attrib)
		*sAttribute = NULL;
	else {
		for (i=0; attributes[i].attrib; i++)
			if (attrib == attributes[i].attrib) {
				*sAttribute = attributes[i].disp_char;
				*(sAttribute+1) = NULL;
				return (sAttribute);
				}
		sprintf (sAttribute, "%2x", attrib);
		}
	return (sAttribute);
}

char * ck_dir (DIR_DISPLAY  *file)
{
	switch (file->ff_attrib) {
			case FA_RDONLY:
			case FA_HIDDEN:
			case FA_SYSTEM:
			case FA_LABEL:
			case FA_DIREC:
				return (strlwr (file->ff_name));

			default: break;

			}
	return (file->ff_name);
}
#define LESSTHAN -1
#define MORETHAN  1
#define EQUAL     0

int file_sorter (const void * p1 , const void * p2)
{
	DIR_DISPLAY *pfile1 = (DIR_DISPLAY*) p1,
					*pfile2 = (DIR_DISPLAY*) p2;
	char	attribute;
	int 	i, retcode;

	if ((pfile1->ff_attrib | pfile2->ff_attrib) & FA_DIREC) {
		if (pfile1->ff_attrib & pfile2->ff_attrib & FA_DIREC) { //both
			retcode = strcmp (pfile1->ff_name, pfile2->ff_name);
			goto Goodbye;
			}
		else
			retcode =  (pfile1->ff_attrib & FA_DIREC) ?
							LESSTHAN : MORETHAN;
		}
	else
		retcode = strcmp (pfile1->ff_name, pfile2->ff_name);

	Goodbye:
#if DEBUGGING
	printf ("%2x %-15s\t%2x %-15s\t%4d\n",
				pfile1->ff_attrib, pfile1->ff_name,
				pfile2->ff_attrib, pfile2->ff_name,	retcode);
#endif
	return (retcode);

}

set_path (char working_path[], char **path, char *where)
{
	char *s;
	struct ffblk ffblock;

	if (*where == '.')
		if (isalnum(*(where+1))) {	// leading dot, not parent
			sprintf (working_path, "*%s", where);
			goto Goodbye;
			}

	s = where + (strlen (where) - 1);   /* last character */
	if (*(s-1) == '*' && *s == '.') {
		strcpy (working_path, where);
		goto Goodbye;
		}
	if (*s == '\\' || *s == ':') {
		sprintf (working_path, "%s*.*", where);
		goto Goodbye;
		}
	if (*s == '*') {
		sprintf (working_path, "%s.*", where);
		goto Goodbye;
		}
	else
		if (*where) {
			strcpy (working_path, where);
			if (!findfirst (where, &ffblock, FA_DIREC)) {
				if (ffblock.ff_attrib == FA_DIREC)   //arg is dir name
					sprintf (working_path, "%s\\*.*", where);
				}
			goto Goodbye;
			}

	return (FALSE);
	Goodbye:
		*path = working_path;
	return (TRUE);
}
